﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Linq;
using System.Web.Script.Serialization;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        List<Sort> sort = new List<Sort>();
        public ActionResult Index()
        {
 //
            return View();
        }
        public ActionResult DataSource(string gridDetails)
        {

            IEnumerable DataSource = OrderRepository.GetAllRecords();
            int count = DataSource.AsQueryable().Count();
            DataResult result = new DataResult(); 
            var gridprop= this.ConvertDM(gridDetails);
            DataOperations operation = new DataOperations();
            //perform sorting
            DataSource = operation.PerformSorting(DataSource, gridprop.SortSettings.SortedColumns);
            //perform filtering
            DataSource = operation.PerformFiltering(DataSource, gridprop.FilterSettings.FilteredColumns);

            if (gridprop.FilterSettings.FilteredColumns.Count > 0)
               result.count = DataSource.AsQueryable().Count();
            else
            result.count = count;

            int skip = (gridprop.PageSettings.CurrentPage - 1) * gridprop.PageSettings.PageSize;
            ////perform paging
            DataSource = operation.PerformSkip(DataSource, skip);
            DataSource = operation.PerformTake(DataSource, gridprop.PageSettings.PageSize);
            
            result.result = DataSource;  //return result of datasource
           
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        public GridProperties ConvertDM(string gridDetails)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridDetails, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
               
            }
            return gridProp;


        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}